/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 20-Oct-2004 by toa02
 *
 */
package uk.ac.ic.doc.kevlar.core.framework;



/**
 * @author Daniel Burke and Steve Zymler
 *  
 */
public interface IFramework 
{
    /**
     * 
     * @return a program repository instance of the currently
     * 			loaded programs.
     */
    IProgramRepository getProgramRepository();
    
    /**
     * @param listener receives events about the new context
     * @return a new context to build a new pipeline in.
     */
    IContext createNewContext(IContextListener listener);
    
    /**
     * 
     * @param context is the context to be removed.
     */
    void removeContext(IContext context);
    
    /**
     * 
     * @param context is the context to be executed. 
     */
    void executeContext(IContext context);       
    
    /**
     * Adds a listener to the framework to be notified on events.
     * @param listener to be added
     */
    void addFrameworkListener( IFrameworkListener listener );
}
