/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 26-Nov-2004
 *
 */
package uk.ac.ic.doc.kevlar.gui.internal.keyboard.actions;

import org.eclipse.swt.events.KeyEvent;

import uk.ac.ic.doc.kevlar.gui.internal.keyboard.Item;
import uk.ac.ic.doc.kevlar.gui.internal.keyboard.KeyBindings;
import uk.ac.ic.doc.kevlar.gui.internal.keyboard.states.ProgramSelectedState;
import uk.ac.ic.doc.kevlar.gui.internal.keyboard.states.State;
import uk.ac.ic.doc.kevlar.gui.internal.pipeline.Program;

/**
 * @author Marc
 **/
public class MoveProgramAction implements IAction {

    public boolean perform(Item event, State s, KeyEvent e) {

        if (s instanceof ProgramSelectedState) {
            
            ProgramSelectedState state = (ProgramSelectedState)s;
            Program program = state.getProgram();

            if (KeyBindings.code("UP").equals(e.keyCode)) {
                
                program.shiftUp();
                
            } else if (KeyBindings.code("DOWN").equals(e.keyCode)) {

                program.shiftDown();
                
            } else if (KeyBindings.code("LEFT").equals(e.keyCode)) {

                program.shiftLeft();
                
            } else if (KeyBindings.code("RIGHT").equals(e.keyCode)) {

                program.shiftRight();
                
            }
                
        }
        
        return false;
                
    }

}
