/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 25-Nov-2004
 *
 */
package uk.ac.ic.doc.kevlar.gui.internal.keyboard.actions.autocomplete.programentry;

import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;

import uk.ac.ic.doc.kevlar.gui.internal.keyboard.AutoCompleteBox;
import uk.ac.ic.doc.kevlar.gui.internal.keyboard.Item;
import uk.ac.ic.doc.kevlar.gui.internal.keyboard.KeyboardManager;
import uk.ac.ic.doc.kevlar.gui.internal.keyboard.actions.IAction;
import uk.ac.ic.doc.kevlar.gui.internal.keyboard.states.ProgramEntryAutoCompleteState;
import uk.ac.ic.doc.kevlar.gui.internal.keyboard.states.ProgramSelectedState;
import uk.ac.ic.doc.kevlar.gui.internal.keyboard.states.State;
import uk.ac.ic.doc.kevlar.gui.internal.pipeline.Program;
import uk.ac.ic.doc.kevlar.gui.internal.pipeline.ProgramEntryListBox;
import uk.ac.ic.doc.kevlar.gui.internal.popup.PopUpBox;
import uk.ac.ic.doc.kevlar.gui.internal.widgets.listbox.ListBox;

/**
 * @author Marc
 **/
public class ShowProgramEntryAutoCompleteAction implements IAction {

/*    protected PopUpBox popup;
    protected ProgramSelectedState state; */
    
    public boolean perform(Item event, State s, KeyEvent e) {
        
        if (s instanceof ProgramSelectedState) {
        
            ProgramSelectedState state = (ProgramSelectedState)s;
            Program program = state.getProgram();
            
	        ListBox listbox = new ProgramEntryListBox(program);
        
            AutoCompleteBox autocomplete = new AutoCompleteBox();
            autocomplete.setListBox(listbox);
            autocomplete.addText(String.valueOf(e.character));
//            autocomplete.setListener(this);
                
            PopUpBox popup = new PopUpBox();
            popup.setSize(new Point(150, 200));
            popup.setName("Select argument or node");
            popup.setContents(autocomplete);
            
            Rectangle area = program.getAbsoluteArea();
            
            popup.popUpAt(new Point(area.x, area.y+area.height));
            
            KeyboardManager.getSingleton().setState(new ProgramEntryAutoCompleteState(popup, autocomplete, program));
                        
        }
        
        return false;
        
    }

/*    public void entryCompleted(Object entry) {
        
        if (entry instanceof IProgramInfoNode && popup != null) {
        
            IProgramInfoNode infoNode = (IProgramInfoNode)entry;
            Program program = state.getProgram();
        
            if (entry instanceof IBasicArgumentInfo && popup != null) {
        
                PopUpManager.getSingleton().hidePopUp(popup);
                popup = null;
                program.addArgument((IBasicArgumentInfo)infoNode);
            
            }
        
            AProgramEntry programEntry = program.getEntry(infoNode);
            
            if (programEntry != null) {
                
                if (programEntry instanceof Argument) {
                    
                    ((Argument)programEntry).showEditor();
                    
                } else if (programEntry instanceof AIONodeEntry) {
                    
                    PipeLineManager.getSingleton().selectNode(((AIONodeEntry)programEntry));
                    
                }
                
            }
                
            PopUpManager.getSingleton().hidePopUp(popup);
            
        }
        
    }

    public void entryCancelled() {

        if (popup != null) {
        
            PopUpManager.getSingleton().hidePopUp(popup);
            popup = null;
            
        }
        
    } */
    
}
