/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 25-Nov-2004
 *
 */
package uk.ac.ic.doc.kevlar.gui.internal.keyboard.states;

import uk.ac.ic.doc.kevlar.gui.internal.keyboard.AutoCompleteBox;
import uk.ac.ic.doc.kevlar.gui.internal.keyboard.actions.TextBoxAction;
import uk.ac.ic.doc.kevlar.gui.internal.popup.PopUpBox;

/**
 * @author Marc
 **/
public abstract class AutoCompleteState extends PopUpState {

    protected AutoCompleteBox autocomplete;
    protected TextBoxState textBoxState;
    protected TextBoxAction textBoxAction;
    
    public AutoCompleteState(PopUpBox popup, AutoCompleteBox autocomplete) {

        super(popup);
        this.autocomplete = autocomplete;
        this.textBoxState = new TextBoxState(autocomplete.getTextBox());
        this.textBoxAction = new TextBoxAction();
        
    }
    
    public void onEnter() {
        
        textBoxState.onEnter();
        
    }
    
    public void onExit() {
        
        textBoxState.onExit();
        
    }
        
    public AutoCompleteBox getAutoComplete() {
        
        return autocomplete;
        
    }
    
    public TextBoxState getTextBoxState() {
        
        return textBoxState;
        
    }
    
    public TextBoxAction getTextBoxAction() {
        
        return textBoxAction;
        
    }
    
}
