/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 03-Nov-2004
 */
package uk.ac.ic.doc.kevlar.gui.internal.pipeline;

import org.eclipse.swt.graphics.Point;

import uk.ac.ic.doc.kevlar.gui.internal.widgets.SelectableButton;

/**
 * @author Marc
 **/
public class Node extends SelectableButton {

    static final String NODE_IMAGE = "node.png";
    static final String NODE_ROLLOVER_IMAGE = "node_rollover.png";
    static final String NODE_SELECTED_IMAGE = "node_selected.png";
    static final String NODE_SELECTED_ROLLOVER_IMAGE = "node_selected_rollover.png";
    
    protected AIONodeEntry entry;
    
    public Node(AIONodeEntry entry) {
        
        super(NODE_IMAGE, NODE_ROLLOVER_IMAGE, NODE_SELECTED_IMAGE, NODE_SELECTED_ROLLOVER_IMAGE);
        this.entry = entry;
        
    }

    public void mouseRelease(Point position, int mouseButton) {
        
        if (mouseButton == MB_LEFT) {
        
            if (!selected) {
            
                PipeLineManager.getSingleton().selectNode(entry);
            
            } else {
            
                PipeLineManager.getSingleton().deselectNode();
                deselect();
            
            }
            
        } else if (mouseButton == MB_RIGHT) {
            
            if (entry.hasPipe()) {
                
                PipeLineManager.getSingleton().removePipe(entry.getPipe());
                redraw();
                
            }
            
        }
        
    }
        
}
