/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 30-Dec-2004
 *
 */
package uk.ac.ic.doc.kevlar.gui.internal.toolbar;


/**
 * @author Marc
 **/
public abstract class ADisableableToolBarEntry extends AToolBarEntry {

    protected String image;
    protected String rolloverImage;
    protected String downImage;
    protected String disabledImage;
    protected boolean enabled;
    
    public ADisableableToolBarEntry(String image, String rolloverImage, String downImage, String disabledImage, int positionIndex) {
        
        super(image, rolloverImage, downImage, positionIndex);
        
        this.image = image;
        this.rolloverImage = rolloverImage;
        this.downImage = downImage;
        this.disabledImage = disabledImage;
        this.enabled = true;
        
    }
    
    public void enable() {
        
        if (!enabled) {
            
            enabled = true;
            setImage(image);
            setRolloverImage(rolloverImage);
            setDownImage(downImage);
            redraw();
            
        }
        
    }
    
    public void disable() {
        
        if (enabled) {
            
            enabled = false;
            setImage(disabledImage);
            setRolloverImage(disabledImage);
            setDownImage(disabledImage);
            redraw();
            
        }
        
    }


}
