/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 14-Nov-2004
 *
 */
package uk.ac.ic.doc.kevlar.gui.internal.widgets.scrollbars;

import org.eclipse.swt.graphics.Point;

import uk.ac.ic.doc.kevlar.gui.internal.AMouseListenerObject;

/**
 * @author Marc
 **/
public abstract class AScrollbarSlider extends AMouseListenerObject {

    protected AScrollbar scrollbar;
    protected Point mouseDownPoint;
    
    public AScrollbarSlider(AScrollbar scrollbar) {
        
        super();
        this.scrollbar = scrollbar;
        this.mouseDownPoint = null;
        
    }
    
    public void mouseEnter() {
        
        redraw();
        applyRedraw();
        
    }
    
    public void mouseExit() {
        
        redraw();
        applyRedraw();
        
    }
    
    public void mousePress(Point position, int button) {
        
        mouseDownPoint = position;
        getMouseFocus();
        redraw();
        applyRedraw();
        
    }
    
    public void mouseRelease(Point position, int button) {
        
        mouseDownPoint = null;
        releaseMouseFocus();
        redraw();
        applyRedraw();
        
    }
    
    public boolean capturesMouse() {
        
        return true;
        
    }
    
    public abstract void mouseMoving(Point position);
    public abstract void setPosition(int pos);
    public abstract void setSize(int size);
    
}
