/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 29-Oct-2004
 */
package uk.ac.ic.doc.kevlar.gui.internal.widgets.scrollbars;

import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;

import uk.ac.ic.doc.kevlar.gui.internal.caches.Utils;


/**
 * @author Marc
 **/
public class VerticalScrollBarSlider extends AScrollbarSlider {

    public VerticalScrollBarSlider(VerticalScrollBar scrollbar) {
        
        super(scrollbar);
        setSize(new Point(21, 50));
        
    }

    public void drawBefore(GC gc, Rectangle redrawArea) {
        
        if (mouseDownPoint != null) {
        
            Utils.drawVerticalBar(gc, "vscrollbar_down", new Rectangle(-redrawArea.x, -redrawArea.y, area.width, area.height));
            
        } else if (isMouseOver()) {

            Utils.drawVerticalBar(gc, "vscrollbar_rollover", new Rectangle(-redrawArea.x, -redrawArea.y, area.width, area.height));
            
        } else {
        
            Utils.drawVerticalBar(gc, "vscrollbar", new Rectangle(-redrawArea.x, -redrawArea.y, area.width, area.height));
            
        }
        
    }
    
    public void mouseMoving(Point position) {
        
        if (mouseDownPoint != null) {
            
            int dy = scrollbar.realValueToScrollbarValue(position.y-mouseDownPoint.y);
            scrollbar.moveBy(dy);
            System.err.println(position.y-mouseDownPoint.y+":"+dy);
            
        }
        
    }    
        
    public void setPosition(int pos) {
        
        setPosition(new Point(0, pos));
        
    }
    
    public void setSize(int size) {
        
        setSize(new Point(AScrollbar.SCROLLBAR_SIZE, size));
        
    }
        
}
